// SPort analog input code by Mike Blandford
// This reads an analog voltage on A3 and returns it
// using SPort protocol to the X8R receiver. The value
// appears on the Tx as though it was from A2 on a D series receiver

#include "oxs_config.h"
#include <Arduino.h>
#include "oxs_out_frsky.h"
#include "SoftwareSerial.h"

OXS_OUT_FRSKY oxs_OutFrsky(PIN_SerialTX/*,Serial*/);

uint16_t Xanalog ;
uint16_t Analog ;
uint16_t AnaAve ;
uint8_t AnaCount ;

//************************************************************************************************** Setup()
void setup()
{
//  pinMode(PIN_LED, OUTPUT); // The signal LED
  oxs_OutFrsky.setup();
//	DDRC = 0x03 ;		// PC0,1 as o/p debug
//	PORTC = 0 ;
}

void readSensors()
{
  	// Read 1.1V reference against AVcc
  	// set the reference to Vcc and the measurement to the internal 1.1V reference
  	ADMUX = _BV(REFS0) | _BV(MUX3) | _BV(MUX2) | _BV(MUX1);

  	ADCSRA |= _BV(ADSC); // Start conversion
  	while (bit_is_set(ADCSRA,ADSC)); // measuring
  	ADMUX = _BV(REFS0) | 3 ;		// prepare for next read

  	uint16_t vref = ADC ;
  
		ADCSRA |= _BV(ADSC); // Start conversion
  	while (bit_is_set(ADCSRA,ADSC)); // measuring

  	uint16_t val = ADC ; // read the value from the sensor
  	ADMUX = _BV(REFS0) | _BV(MUX3) | _BV(MUX2) | _BV(MUX1) ; // Leave ready for next time
		// Vref is value for 1.1V, so multiply by 3
		vref *= 3 ;
		uint32_t x ;
		x = val ;
		x *= 256 ;
		x /= vref ;
		val = x ;
		AnaAve += val ;
		AnaCount += 1 ;
		if ( AnaCount > 3 )
		{
			val = AnaAve / 4 ;
			Xanalog = val ;
			if ( val > 255 )
			{
				val = 255 ;		
			}
			Analog = val ;
			AnaCount = 0 ;
			AnaAve = 0 ;
		}
}

  #define TIME_TO_SEND() (1)
//************************************************************************************************** Loop()
void loop(){
  
  if (TIME_TO_SEND())
  {
    if (oxs_OutFrsky.timeToSend())
		{
      oxs_OutFrsky.sendData();
      readSensors();
    }
  }
}

